#!/bin/sh
PREREQ=""
prereqs()
{
    echo "$PREREQ"
}

case $1 in
prereqs)
    prereqs
    exit 0
    ;;
esac

. /scripts/functions

# Principe : Monter la partition contenant la clé du conteneur LUKS et la lire

#touch /boot/test.txt

#exec /bin/sh --login
#busybox bin/sh -c "/bin/sh"
# Définition des variables
tmpMnt="/keyTmpMnt"                 # Répertoire temporaire sur lequel est montée le périphérique amovible contenant la clé
keyDev=""                     # Point de montage
keyPath="skul"                    # Répertoire contenant la clé
keyPartdisk="usb-VBTM_Store__n__Go_AAAAAAA12AAAAAAA-0:0"
keyPartUUID="aaaaaaab-d84a-4bfa-a60d-920baaaaaaaa" # UUID de la partition contenant la clé
keyPartfs="ext4"                  # Système de fichier de la partition contenant la clé
keyFile="clefsecrete.key"                  # nom du fichier contenant la clé

# On laisse l'ensemble des partitions être prises en compte
sleep 2

# Extraire le point de montage sur lequel la clé est
keyDisk=$(ls -1 /dev/disk/by-id/ | grep $keyPartdisk)
#keyDisk1=$(ls -1 /dev/disk/by-id/ | grep "$keyPartdisk-part1")
keyDev=$(blkid | grep "$keyPartUUID" | cut -d: -f1)

# verif si disque USB present
if [ -e "$keyDisk" ]; then
  echo "!!!!!!!!!!!!!! disque présent !!!!!!!!!!!!!!!!!!"
fi

# Si le répertoire temporaire de montage de la partition contenant la clé n'existe pas, on le créé
if [ ! -d "$tmpMnt" ]; then
  mkdir "$tmpMnt" 2>/dev/null
fi

# On vérifie que ni la partition contenant la clé, ni le répertoire de montage ne sont montés
if [ ! $(mount | grep "$tmpMnt") ] && [ ! $(mount | grep "$keyDev") ]; then
  # On monte la partition contenant la clé sur le répertoire temporaire de montage
  mount "$keyDev" "$tmpMnt" -t "$keyPartfs" || mount "$keyDisk-part1" "$tmpMnt" -t "$keyPartfs"
#>> "$tmpMnt/$keyPath/test.txt"

  # tests ......................
  touch "$tmpMnt/oleo.txt"
  df > "$tmpMnt/oleo.txt"
  echo "---" >> "$tmpMnt/oleo.txt"
  blkid >> "$tmpMnt/oleo.txt"
  echo "---" >> "$tmpMnt/oleo.txt"
  lsblk >> "$tmpMnt/oleo.txt"

  # Si on peut lire la clé, on l'affiche et on la transmet à cryptsetup
  if [ -f "$tmpMnt/$keyPath/$keyFile" ]; then
    echo "yuyigfiyfydgdgdsgiugiygigIGIUTUGCYRYTUGVHBIYUTYUTCUTCUTCUTC"
    cryptsetup --test-passphrase --verbose open /dev/sda5 sda5_crypt --key-file $tmpMnt/$keyPath/$keyFile | grep clé | awk -F" " '{print $4}' #| tee "$tmpMnt/$keyPath/test.txt"
  else
  # Sinon, on demande la saisie du mot de passe
    #echo "toto" > /boot/test.txt
    echo "Pas de clé valide trouvée" #>&2
    #echo -n "Saisie du mot de passe : " >&2
    read -p "Saisie du mot de passe : " -s -r A
    #~ read -s -r A
    echo -n "$A" | cryptsetup open /dev/sda5 sda5_crypt - >> "$tmpMnt/$keyPath/test.txt"

  fi

else
  echo "Impossible de monter le périphérique sur son point de montage" >/dev/null 2>&1
fi

sleep 1
umount "$tmpMnt" #2>/dev/null
rmdir "$tmpMnt" #2>/dev/null
#exit 0
